<?php

namespace COC\Util;

use \Teknisa\GER\Utilities\Configuration;
use \Zeedhi\Framework\DataSource\Manager\Doctrine\NameProvider;

class NameProviderImpl implements NameProvider {

    public function getClassName($tableName) {}

    public function getDataSourceByName($dataSourceName) {
    	$dataSourcesSubModels = $this->getDataSources();
        $dataSourceDirectory = $dataSourcesSubModels[$dataSourceName];
        return Configuration::factoryFromFileLocation($dataSourceDirectory, $dataSourceName);
    }

    private function getDataSources() {
    	$ds = DIRECTORY_SEPARATOR;
    	$gerDataSources = $this->getGerDataSources($ds);
    	$facDataSources = $this->getFacDataSources($ds);
    	return array_merge($gerDataSources, $facDataSources);
    }

    private function getGerDataSources($ds) {
    	$dataSources = file_get_contents(__DIR__.$ds.'..'.$ds.'..'.$ds.'..'.$ds.'..'.$ds.'..'.$ds.'ger'.$ds.'backend'.$ds.'config'.$ds.'dataSourcesMapping.json');
        return json_decode($dataSources, true);
    }

    private function getFacDataSources($ds) {
    	$dataSources = file_get_contents(__DIR__.$ds.'..'.$ds.'..'.$ds.'..'.$ds.'config'.$ds.'dataSourcesMapping.json');
        return json_decode($dataSources, true);
    }

}