<?php 

namespace Controllers;

use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\GER\Utilities\Environment;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO;
use \Doctrine\ORM\EntityManager;

class Produtosmacia extends \Teknisa\GER\Controllers\TeknisaCrud {
    
    protected $entityManager;
    protected $dataSourceManager;
    protected $environment;
    protected $connection;
    protected $parameterBag;

    public function __construct($entityManager, Manager $dataSourceManager, Environment $environment, $connection, $parameterBag) {
        $this->entityManager = $entityManager;
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
        $this->connection = $connection;
        $this->parameterBag = $parameterBag;
	}

    public function geraProdutosmacia (DTO\Request\DataSet $request, DTO\Response $response){
		foreach ($request->getDataSet()->getRows() as $row) {
	        $connection = $this->entityManager->getConnection();
	        $procedure = new StoredProcedure($connection, 'PROD_MANUALCIAM');
	        $procedure->addParam(new Param('P_CDCIA', Param::PARAM_INPUT, $row['CDCIA'], Param::PARAM_TYPE_STR));
	        $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $row['CDFILIAL'], Param::PARAM_TYPE_STR));
	        $procedure->addParam(new Param('P_CDMANCIA', Param::PARAM_INPUT, $row['CDMANUAL'], Param::PARAM_TYPE_STR));
	        $procedure->addParam(new Param('P_NRORG', Param::PARAM_INPUT, $row['NRORG'], Param::PARAM_TYPE_STR));
	        $procedure->addParam(new Param('P_DTCUSTO', Param::PARAM_INPUT, null, Param::PARAM_TYPE_STR));
	        $procedure->addParam(new Param('P_IDTIPOCUSTO', Param::PARAM_INPUT, null, Param::PARAM_TYPE_STR));
	        $procedure->addParam(new Param('P_CDCONTROLE', Param::PARAM_OUTPUT, null, null, 20));
	        $resultado = $procedure->execute();
	        $response->addDataset(new DataSet('response', $resultado));
	    }
	}
} 