<?php

namespace Controllers;

use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DTO\Response\Error;
use \Zeedhi\Framework\DataSource\DataSet;
use \Zeedhi\Framework\DataSource\FilterCriteria;
use \Zeedhi\Framework\DataSource\Manager;
use \Zeedhi\Framework\DataSource\ParameterBag;
use \Teknisa\GER\Services\CrudService;
use \Teknisa\GER\Utilities\Messages;
use Controllers;
use Zeedhi\Framework\ORM\DateTime;

class WorkflowReceitaController extends \Teknisa\GER\Controllers\TeknisaCrud {

	protected $dataSourceName;
	protected $parameterBagColumns = array();
    protected $environment;
	protected $parameterBag;
   
    public function __construct($crudService, $parameterBag, $dataSourceManager, $environment) {
        $this->crudService = $crudService;
        $this->parameterBag=$parameterBag;
        $this->dataSourceManager = $dataSourceManager;
        $this->environment=$environment;  

    }
     /*
         Processo para gerar, apenas, Workflow de INCLUSÃO DE UMA NOVA RECEITA

         *TO DO* Implementar processo geral para qualquer tipo de alteração
         feita na tela de Cadatros de Receita que esteja registrada na tabela de
         ITEMPROCAPROVA
     */

    // public function generateWflowEdit(DTO\Request\Row $request, DTO\Response $response){

    // }
    private function createRequest($row, $dataSourceName){
        $newDataSet = new DataSet($dataSourceName, $row);
        $newRequest = new DTO\Request\DataSet($newDataSet, "", "", "");
        return $newRequest;
    }
    public function returnColumns(){
        return $this->crudService->getColumnsToReturn();
    }
    public function getOperatorsInvolved ($row, DTO\Response $response){
        $this->dataSourceName = 'operitempaprova';
        $this->parameterBagColumns = array();
        $condition = array(
            array(
                "columnName" => "NRPROCESSOAPROVA",
                "operator" => "=",
                "value" => $row["NRPROCESSOAPROVA"]
            ),
            array(
                "columnName" => "NRITEMPROCAPROVA",
                "operator" => "=",
                "value" => $row["NRITEMPROCAPROVA"]
            )
        );
        $filterCriteria= new FilterCriteria($this->dataSourceName, $condition);
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSetOper = $this->dataSourceManager->findBy($newFilterCriteria);
        $operEnvolvidos = $dataSetOper->getRows();
        if(empty($operEnvolvidos)){
            return [];
        } else {
            return $operEnvolvidos;
        }
    }
    public function getItemprocaprova($row, DTO\Response $response){
        $this->dataSourceName = 'itemprocaprova';
        $this->parameterBagColumns = array();
        $condition = array(
            array(
                "columnName" => "NRPROCESSOAPROVA",
                "operator" => "=",
                "value" => $row["NRPROCESSOAPROVA"]
            ),
            array(
                "columnName" => "NRITEMPROCAPROVA",
                "operator" => "=",
                "value" => $row["NRITEMPROCAPROVA"]
            )
        );
        $filterCriteria= new FilterCriteria($this->dataSourceName, $condition);
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSetOper = $this->dataSourceManager->findBy($newFilterCriteria);
        $itemaprova = $dataSetOper->getRows();
        if(empty($itemaprova)){
            return [];
        } else {
            return $itemaprova;
        }
    }
    public function newProcessWorkflow($row, $request, DTO\Response $response){
        $this->dataSourceName = 'workflow';
        $newWorkflow = array(
            "__is_new" => true,
            "__is_new_code" => true,
            "__new_code_pk" => "WORKFLOW",
            "__table_pk" => "NRWORKFLOW",
            "__new_code_length" => 20,
            "__cast_number" => true,
            "__columns_to_return" => ["NRWORKFLOW"],
            "IDTIPOPERWFLOW" => $row['IDTIPOPERWFLOW'],
            "NRPROCESSOAPROVA" => $row['NRPROCESSOAPROVA'],
            "NRITEMPROCAPROVA" => $row['NRITEMPROCAPROVA'],   
            "DSMOTIVOWFLOW" => $row['DSMOTIVOACAO'],
            "IDSITWORKFLOW" => $row['IDSITWORKFLOW'],
            "NMITEMWFLOW" => $row['DSRECEITA'],
            "CDOPERADOR" => $this->environment->getCdOperador()
        ); 
        parent::save($this->createRequest(array($newWorkflow), $this->dataSourceName), $response);
        $columnsReturn = $this->returnColumns();
        if(empty($columnsReturn)){
             $response->setError(new Error("Error! Nenhuma coluna retornada", 500));   
        } else {
            return $columnsReturn; 
        }
    }
    public function operWorkflow($operadores, $workflow, DTO\Response $response){
        $this->dataSourceName = 'operworkflow';
        $dataSaveOper = array();
        foreach ($operadores as $oper) {
            $date = \DateTime::createFromFormat('d/m/Y H:i:s', $this->environment->getCurrentTime()->format("d/m/Y H:i:s"));
            $date->add(new \DateInterval('P'.$oper['NRDIASOPERAPRO'].'D'));
            $newOperWorkflow = array(
                "__is_new" => true,
                "NRWORKFLOW" => $workflow[0]['NRWORKFLOW'],
                "CDOPERADOR" => $oper['CDOPERADOR'],
                "IDSITOPERWFLOW" => 'P',
                "DTLIMITEWFLOW" => $date->format('d/m/Y H:i:s')
            ); 
            array_push($dataSaveOper, $newOperWorkflow);
        }
        parent::save($this->createRequest($dataSaveOper, $this->dataSourceName), $response);
    }
    public function saveDadoswflow($row, $workflow, $response){
        $this->dataSourceName = 'dadoswflow';
        $dataSaveDados = array();
        $newDadosWorkflowAtivo = array(
            "__is_new" => true,
            "NRWORKFLOW" => $workflow[0]['NRWORKFLOW'],
            "NMTABELAWFLOW" => $row["NMTABELAWFLOW"], //Fixed for Inclusion Process
            "NMCAMPOWFLOW" => $row['NMCAMPOWFLOW'],   //Fixed for Inclusion Process 
            "DSINFORANTERIOR" => $row['DSINFORANTERIOR'],  //Fixed for Inclusion Process
            "DSINFORATUAL" => $row['DSINFORATUAL'],   //Fixed for Inclusion Process
            "DSPRIMARYKEY" => 'CDRECEITA='.$row['CDRECEITA'].';NRORG='.$this->environment->getNrOrg()
        );
        if(!empty($row['NRVARIACAOREC']))
            $newDadosWorkflowAtivo['DSPRIMARYKEY'] .= ';NRVARIACAOREC='.$row['NRVARIACAOREC'];
        if (!empty($row['CDPRODUTO']))
            $newDadosWorkflowAtivo['DSPRIMARYKEY'] .= ';CDPRODUTO='.$row['CDPRODUTO'];
        if (!empty($row['CDSUBRECEITA']))
            $newDadosWorkflowAtivo['DSPRIMARYKEY'] .= ';CDSUBRECEITA='.$row['CDSUBRECEITA'];
        if (!empty($row['UNIDADE']))
            $newDadosWorkflowAtivo['DSPRIMARYKEY'] .= ';CDRECEITA='.$row['UNIDADE'];
        array_push($dataSaveDados, $newDadosWorkflowAtivo);
        parent::save($this->createRequest($dataSaveDados, $this->dataSourceName), $response);
    }
    public function updateDadoswflow($oldRow, $newRow, $workflow, $response){
        $this->dataSourceName = 'dadoswflow';
        $dataSaveDados = array();
        $newDadosWorkflowAtivo = array(
            "__is_new" => true,
            "NRWORKFLOW" => $workflow[0]['NRWORKFLOW'],
            "NMTABELAWFLOW" => $newRow["NMTABELAWFLOW"], //Fixed for Inclusion Process
            "NMCAMPOWFLOW" => $newRow['NMCAMPOWFLOW'],  
            "DSINFORANTERIOR" => $oldRow['DSINFORANTERIOR'], 
            "DSINFORATUAL" => $newRow['DSINFORATUAL'],   
            "DSPRIMARYKEY" => 'CDRECEITA='.$oldRow['CDRECEITA'].';NRORG='.$this->environment->getNrOrg()
        );
        if(!empty($oldRow['NRVARIACAOREC'])){
            $newDadosWorkflowAtivo['DSPRIMARYKEY'] .= ';NRVARIACAOREC='.$oldRow['NRVARIACAOREC'];
        }
        array_push($dataSaveDados, $newDadosWorkflowAtivo);
        parent::save($this->createRequest($dataSaveDados, $this->dataSourceName), $response);
    }
}