<?php

namespace Services;

use \Doctrine\ORM\EntityManager;

class CompanhiaService{
	protected $entityManager;

	public function __construct(EntityManager $entityManager) {
		$this->entityManager = $entityManager;
	}

	public function getOldLogocia($cdcia, $nrorg){
		$params = array("cdcia" => $cdcia, "nrorg" => $nrorg);
		$conn = $this->entityManager->getConnection();
		$rows = $conn->fetchAll("SELECT FGLOGOCIA FROM COMPANHIA WHERE CDCIA = :cdcia AND NRORG = :nrorg", $params);
		return (isset($rows[0]) && isset($rows[0]['FGLOGOCIA'])) ? $rows[0]['FGLOGOCIA'] : null;
	}
	
	public function saveClientAddress($stateAbbrv, $cityCode, $idtpEndeClie, $address, $complement, $countryCode, $neighborhood, $zipCode, $telephone, $ramal, $email, $nrorg, $nrTelexClie, $nrFaxClie, $clientCode) {
		$params = [];
		$query = "INSERT INTO ENDECLIE( ";
		$values = " VALUES (";
		if(!empty($clientCode)) {
			$params['CDCLIENTE'] = $clientCode;
			$query .= "CDCLIENTE,";
			$values .= ":CDCLIENTE,";
		}
		if(!empty($idtpEndeClie)) {
			$params['IDTPENDECLIE'] = $idtpEndeClie;
			$query .= " IDTPENDECLIE,";
			$values .= " :IDTPENDECLIE,";
		}
		if(!empty($countryCode)) {
			$params['CDPAIS'] = $countryCode;
			$query .= " CDPAIS,";
			$values .= " :CDPAIS,";
		}
		if(!empty($stateAbbrv)) {
			$params['SGESTADO'] = $stateAbbrv;
			$query .= " SGESTADO,";
			$values .= " :SGESTADO,";
		}
		if(!empty($cityCode)) {
			$params['CDMUNICIPIO'] = $cityCode;
			$query .= " CDMUNICIPIO,";
			$values .= " :CDMUNICIPIO,";
		}
		if(!empty($address)) {
			$params['DSENDECLIE'] = $address;
			$query .= " DSENDECLIE,";
			$values .= " :DSENDECLIE,";
		}
		if(!empty($neighborhood)) {
			$params['NMBAIRCLIE'] = $neighborhood;
			$query .= " NMBAIRCLIE,";
			$values .= " :NMBAIRCLIE,";
		}
		if(!empty($complement)) {
			$params['DSCOMPENDCLI'] = $complement;
			$query .= " DSCOMPENDCLI,";
			$values .= " :DSCOMPENDCLI,";
		}
		if(!empty($zipCode)) {
			$params['NRCEPCLIE'] = $zipCode;
			$query .= " NRCEPCLIE,";
			$values .= " :NRCEPCLIE,";
		}
		if(!empty($telephone)) {
			$params['NRTELECLIE'] = $telephone;
			$query .= " NRTELECLIE,";
			$values .= " :NRTELECLIE,";
		}
		if(!empty($ramal)) {
			$params['NRRAMALCLIE'] = $ramal;
			$query .= " NRRAMALCLIE,";
			$values .= " :NRRAMALCLIE,";
		}
		if(!empty($nrTelexClie)) {
			$params['NRTELEXCLIE'] = $nrTelexClie;
			$query .= "NRTELEXCLIE";
			$values .= ":NRTELEXCLIE";
		}
		if(!empty($nrFaxClie)) {
			$params['NRFAXCLIE'] = $nrFaxClie;
			$query .= " NRFAXCLIE,";
			$values .= " :NRFAXCLIE,";
		}
		if(!empty($email)) {
			$params['DSEMAILCLIE'] = $email;
			$query .= " DSEMAILCLIE,";
			$values .= " :DSEMAILCLIE,";
		}
		if(!empty($nrorg)) {
			$params['NRORG'] = $nrorg;
			$query .= " NRORG,";
			$values .= " :NRORG,";
		}
		$query = rtrim($query , ',');
		$values = rtrim($values , ',');
		$query = $query.")";
		$values = $values.")";

		$conn = $this->entityManager->getConnection();
		// $query = "INSERT INTO ENDECLIE (CDCLIENTE, IDTPENDECLIE, CDPAIS, SGESTADO, CDMUNICIPIO, DSENDECLIE, NMBAIRCLIE, DSCOMPENDCLI, NRCEPCLIE, NRTELECLIE, NRRAMALCLIE, NRTELEXCLIE, DSEMAILCLIE, NRORG)
		// VALUES (:CDCLIENTE, :IDTPENDECLIE, :CDPAIS, :SGESTADO, :CDMUNICIPIO, :DSENDECLIE, :NMBAIRCLIE, :DSCOMPENDCLI, :NRCEPCLIE, :NRTELECLIE, :NRRAMALCLIE, :NRTELEXCLIE, :DSEMAILCLIE, :NRORG)";
		
		$insert = $conn->prepare($query.$values);
		$insert->execute($params);
	}
	
	public function editClientAddress ($stateAbbrv, $cityCode, $idtpEndeClie, $address, $complement, $countryCode, $neighborhood, $zipCode, $telephone, $ramal, $email, $nrorg, $nrTelexClie, $nrFaxClie, $clientCode) {
		$params = ['CDCLIENTE' => $clientCode];
		$query = "UPDATE ENDECLIE ";
		$update = "SET ";
		$where = "WHERE CDCLIENTE = :CDCLIENTE";
		if(!empty($countryCode)) {
			$params['CDPAIS'] = $countryCode;
			$update .="CDPAIS = :CDPAIS, ";
		}
		if(!empty($idtpEndeClie)) {
			$params['IDTPENDECLIE'] = $idtpEndeClie;
			$update .= "IDTPENDECLIE = :IDTPENDECLIE, ";
		}
		if(!empty($stateAbbrv)) {
			$params['SGESTADO'] = $stateAbbrv;
			$update .= "SGESTADO = :SGESTADO, ";
		}
		if(!empty($cityCode)) {
			$params['CDMUNICIPIO'] = $cityCode;
			$update .= "CDMUNICIPIO = :CDMUNICIPIO, ";
		}
		if(!empty($address)) {
			$params['DSENDECLIE'] = $address;
			$update .= "DSENDECLIE = :DSENDECLIE, ";
		}
		if(!empty($neighborhood)) {
			$params['NMBAIRCLIE'] = $neighborhood;
			$update .= "NMBAIRCLIE = :NMBAIRCLIE, ";
		}
		if(!empty($complement)) {
			$params['DSCOMPENDCLI'] = $complement;
			$update .= "DSCOMPENDCLI = :DSCOMPENDCLI, ";
		}
		if(!empty($zipCode)) {
			$params['NRCEPCLIE'] = $zipCode;
			$update .= "NRCEPCLIE = :NRCEPCLIE, ";
		}
		if(!empty($telephone)) {
			$params['NRTELECLIE'] = $telephone;
			$update .= "NRTELECLIE = :NRTELECLIE, ";
		}
		if(!empty($ramal)) {
			$params['NRRAMALCLIE'] = $ramal;
			$update .= "NRRAMALCLIE = :NRRAMALCLIE, ";
		}
		if(!empty($nrTelexClie)) {
			$params['NRTELEXCLIE'] = $nrTelexClie;
			$update .= "NRTELEXCLIE = NRTELEXCLIE, ";
		}
		if(!empty($nrFaxClie)) {
			$params['NRFAXCLIE'] = $nrFaxClie;
			$update .= "NRFAXCLIE = :NRFAXCLIE, ";
		}
		if(!empty($email)) {
			$params['DSEMAILCLIE'] = $email;
			$update .= "DSEMAILCLIE = :DSEMAILCLIE, ";
		}
		
		$update = rtrim($update , ', ');
		$update .= " ";
		
		// var_dump($params);
		
		$conn = $this->entityManager->getConnection();
		
		$insert = $conn->prepare($query.$update.$where);
		$insert->execute($params);
		
	}
}